#ifndef DISCONTINUOUSLAGRANGEFE_IS_INCLUDED
#define DISCONTINUOUSLAGRANGEFE_IS_INCLUDED 

#include <LagrangeFE.h>

class DiscontinuousLagrangeFE : public LagrangeFE{
  int element; 
  public: 
  DiscontinuousLagrangeFE(); 
  ~DiscontinuousLagrangeFE() {}

  virtual void set(int order); 
  virtual void set_element_number(int element); 
  virtual void set(Polygon& p);  
  virtual void compute_basis_functions();  
  virtual int nbf(); 
  virtual GiNaC::ex N(int i);  
  virtual GiNaC::ex dof(int i); 
}; 


// FIXME: would like to have this element also 
// in vector version since this it will give
// nice code in the element matrix e.g.: 
//       div(vfe.N(j))*pfe.N(i)

class VectorDiscontinuousLagrangeFE : public VectorLagrangeFE {
  protected: 
  int size; 
  int element; 
  public: 
  VectorDiscontinuousLagrangeFE(); 
  ~VectorDiscontinuousLagrangeFE() {}

  virtual void set(int order); 
  virtual void set_element_number(int element); 
  virtual void set(Polygon& p);  
  virtual void set_size(int size_);  
  virtual void compute_basis_functions();  
  virtual int nbf(); 
  virtual GiNaC::ex N(int i);  
  virtual GiNaC::ex dof(int i); 
}; 

#endif
